/* Keep these headers */
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <tice.h>

/* Standard headers - it's recommended to leave them included */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <debug.h>

#include <lib/ce/graphx.h>
#include <lib/ce/keypadc.h>
#include <lib/ce/fileioc.h>

#include "main.h"

/* Other available headers */
// stdarg.h, setjmp.h, assert.h, ctype.h, float.h, iso646.h, limits.h, errno.h

bool exitSection;
bool quit;
unsigned char key;
int tilerow;
int tilecolumn;
int tilenumber;
int boardx;
int boardy;
int selectx;
int selecty;
int score;
unsigned char tiles[10][10];
Tile buffer1;
Tile buffer2;
Tile buffer3;

bool buffer1Active;
bool buffer2Active;
bool buffer3Active;

int currentBufferInUse;
int whichL;
bool canDrawTileBool;
bool movesRemaining;
int flicker;
int oldHS;
bool darkMode;
bool lastClearCheck;
#define lg ((gfx_image_t*)logo)

void main() {
	ti_CloseAll();
	gfx_Begin( gfx_8bpp );
	gfx_SetDrawBuffer();
	setDefaultHS();
	flicker = 0;
	quit = false;
	exitSection = false;
	darkMode = false;
	while (kb_AnyKey()) {

	}
	gfx_SetPalette(logo_pal, sizeof logo_pal,0);
    gfx_palette[117] = 0x0000;
	gfx_SetTextFGColor(0x75);
	while (exitSection == false) {
		gfx_SetTextXY(100, 120);
		gfx_PrintString("Highscore: ");
		gfx_SetTextXY(100+75, 120);
		gfx_PrintInt(oldHS,5);
		flicker++;
		if (flicker <35) {
			gfx_SetTextXY(85, 160);
			gfx_PrintString("Press any key to start ");
			gfx_SetTextXY(96, 170);
			gfx_PrintString("Press clear to exit");
		}
		if (flicker == 71) {
			flicker = 0;
		}
        gfx_Sprite(lg,110,80);
		gfx_SwapDraw();
		gfx_FillScreen(0xFF);
		key = kb_ScanGroup(kb_group_6);
		if (key & kb_Clear) {
			gfx_FillScreen(0xFF);
			exitSection = true;
			quit = true;
			while (kb_AnyKey()) {

			}
		}
		if (kb_AnyKey()) {
			gfx_FillScreen(0xFF);
			exitSection = true;
			while (kb_AnyKey()) {

			}
		}
	}
	if (!quit) {
		startGame();
	}
	else {
		gfx_End();
		_OS(prgm_CleanUp);
	}
}
void setDefaultHS() {
	unsigned int index, file, i;
	/* Close all open file handles before we try any funny business */
	ti_CloseAll();

	/* Open a file for writting -- delete it if it already exists */
	file = ti_Open("tentenhs", "a+");

	if (file) {
		ti_Rewind(file);
		ti_Read(&oldHS, sizeof(int), 1, file);
	}
	else {
		oldHS = 0;
	}
	ti_Close(file);

}
void drawBuffers() {
	int xx, yy;
	if (currentBufferInUse == 1) {
			for (xx = 0; xx < 5; xx++)
			{
				for (yy = 0; yy < 5; yy++)
				{
					if (buffer2.shape[xx][yy] == true) { // if the tile is set 
						gfx_SetColor(buffer2.color);
						gfx_FillRectangle_NoClip(xx * 21 + 215, yy * 21 + 19, 20, 20);
						fixCorners(xx * 21 + 215, yy * 21 + 19);
					}
				}
			}

			for (xx = 0; xx < 5; xx++)
			{
				for (yy = 0; yy < 5; yy++)
				{
					if (buffer3.shape[xx][yy] == true) { // if the tile is set 
						gfx_SetColor(buffer3.color);
						gfx_FillRectangle_NoClip(xx * 21 + 215, yy * 21 + 19 +110, 20, 20);
						fixCorners(xx * 21 + 215, yy * 21 + 19 +110);
					}
				}
			}
	}
	if (currentBufferInUse == 2) {
		for (xx = 0; xx < 5; xx++)
		{
			for (yy = 0; yy < 5; yy++)
			{
				if (buffer3.shape[xx][yy] == true) { // if the tile is set 
					gfx_SetColor(buffer3.color);
					gfx_FillRectangle_NoClip(xx * 21 + 215, yy * 21 + 19, 20, 20);
					fixCorners(xx * 21 + 215, yy * 21 + 19);
				}
			}
		}

		for (xx = 0; xx < 5; xx++)
		{
			for (yy = 0; yy < 5; yy++)
			{
				if (buffer1.shape[xx][yy] == true) { // if the tile is set 
					gfx_SetColor(buffer1.color);
					gfx_FillRectangle_NoClip(xx * 21 + 215, yy * 21 + 19 + 110, 20, 20);
					fixCorners(xx * 21 + 215, yy  * 21 + 19 + 110);
				}
			}
		}
	}
	if (currentBufferInUse == 3) {
		for (xx = 0; xx < 5; xx++)
		{
			for (yy = 0; yy < 5; yy++)
			{
				if (buffer1.shape[xx][yy] == true) { // if the tile is set 
					gfx_SetColor(buffer1.color);
					gfx_FillRectangle_NoClip(xx * 21 + 215, yy * 21 + 19, 20, 20);
					fixCorners(xx* 21 + 215, yy * 21 + 19);
				}
			}
		}

		for (xx = 0; xx < 5; xx++)
		{
			for (yy = 0; yy < 5; yy++)
			{
				if (buffer2.shape[xx][yy] == true) { // if the tile is set 
					gfx_SetColor(buffer2.color);
					gfx_FillRectangle_NoClip(xx * 21 + 215, yy * 21 + 19 + 110, 20, 20);
					fixCorners(xx * 21 + 215, yy * 21 + 19 + 110);
				}
			}
		}
	}
}
void saveNewHS(int newHS) {
	unsigned int index, file, i;
	if (newHS > oldHS) {
		oldHS = newHS;
		/* Close all open file handles before we try any funny business */
		ti_CloseAll();
		/* Open a file for writting -- delete it if it already exists */
		file = ti_Open("tentenhs", "a+");

		if (file) {
			ti_Rewind(file);
			ti_Write(&newHS, sizeof(int), 1, file);
		}
		ti_Close(file);
	}

}
void startGame()
{
    gfx_Begin( gfx_8bpp );
    gfx_SetDrawBuffer();
    gfx_SetTextFGColor(0xFF00);
	gfx_FillScreen(0xFF);
	gfx_SwapDraw();
	srand(*(unsigned long*)0xF30044);
	clearTile(&buffer1);
	clearTile(&buffer2);
	clearTile(&buffer3);
	setRandomTile(&buffer1);
	setRandomTile(&buffer2);
	setRandomTile(&buffer3);
	buffer1Active = true;
	buffer2Active = true;
	buffer3Active = true;
	currentBufferInUse = 1;
	exitSection = false;
	movesRemaining = true;
	boardx = 3;
	boardy = 18;
	selectx = 0;
	selecty = 0;
	score = 0;
	drawBoardStart();
	canDrawTileBool = true;
	while (exitSection == false) {
		checkBuf();
		drawBoardRF();
		gfx_SetTextXY(275, 5);
		gfx_PrintInt(score, 5);
		if (currentBufferInUse == 1) {
			drawTileHover(buffer1, selectx, selecty);
		}
		if (currentBufferInUse == 2) {
			drawTileHover(buffer2, selectx, selecty);
		}
		if (currentBufferInUse == 3) {
			drawTileHover(buffer3, selectx, selecty);
		}
		/*if (canDrawTileBool == true) {
			gfx_SetColor(0x47);
			gfx_NoClipRectangleOutline(selectx * 21 + boardx, selecty * 21 + boardy, 21, 21);
		}
		else {
			gfx_SetColor(0xE0);
			gfx_NoClipRectangleOutline(selectx * 21 + boardx, selecty * 21 + boardy, 21, 21);
		}*/
		drawBuffers();
		gfx_SwapDraw();
		if (!darkMode) {
            gfx_palette[255] = gfx_RGBTo1555(255, 255, 255);
		}
		else {
            gfx_palette[255] = gfx_RGBTo1555(26, 26, 26);
		}
		gfx_FillScreen(0xFF);
		key = kb_ScanGroup(kb_group_7);
		if (key & kb_Down) {
			if (currentBufferInUse == 1) {
				inBounds(buffer1, selectx, selecty+1);
			}
			if (currentBufferInUse == 2) {
				inBounds(buffer2, selectx, selecty+1);
			}
			if (currentBufferInUse == 3) {
				inBounds(buffer3, selectx, selecty+1);
			}
			if (selecty < 9 && canDrawTileBool) {
				selecty++;
				if (currentBufferInUse == 1) {
					canDrawTile(buffer1, selectx, selecty);
				}
				if (currentBufferInUse == 2) {
					canDrawTile(buffer2, selectx, selecty);
				}
				if (currentBufferInUse == 3) {
					canDrawTile(buffer3, selectx, selecty);
				}
			}
		}
		if (key & kb_Up) {
			if (currentBufferInUse == 1) {
				inBounds(buffer1, selectx, selecty-1);
			}
			if (currentBufferInUse == 2) {
				inBounds(buffer2, selectx, selecty-1);
			}
			if (currentBufferInUse == 3) {
				inBounds(buffer3, selectx, selecty-1);
			}
			if (selecty > 0 && canDrawTileBool) {
				selecty--;
				if (currentBufferInUse == 1) {
					canDrawTile(buffer1, selectx, selecty);
				}
				if (currentBufferInUse == 2) {
					canDrawTile(buffer2, selectx, selecty);
				}
				if (currentBufferInUse == 3) {
					canDrawTile(buffer3, selectx, selecty);
				}
			}
		}
		if (key & kb_Left) {
			if (currentBufferInUse == 1) {
				inBounds(buffer1, selectx-1, selecty);
			}
			if (currentBufferInUse == 2) {
				inBounds(buffer2, selectx-1, selecty);
			}
			if (currentBufferInUse == 3) {
				inBounds(buffer3, selectx-1, selecty);
			}
			if (selectx > 0 && canDrawTileBool) {
				selectx--;
				if (currentBufferInUse == 1) {
					canDrawTile(buffer1, selectx, selecty);
				}
				if (currentBufferInUse == 2) {
					canDrawTile(buffer2, selectx, selecty);
				}
				if (currentBufferInUse == 3) {
					canDrawTile(buffer3, selectx, selecty);
				}
			}
		}
		if (key & kb_Right) {
			if (currentBufferInUse == 1) {
				inBounds(buffer1, selectx+1, selecty);
			}
			if (currentBufferInUse == 2) {
				inBounds(buffer2, selectx+1, selecty);
			}
			if (currentBufferInUse == 3) {
				inBounds(buffer3, selectx+1, selecty);
			}
			if (selectx < 9 && canDrawTileBool) {
				selectx++;
				if (currentBufferInUse == 1) {
					canDrawTile(buffer1, selectx, selecty);
				}
				if (currentBufferInUse == 2) {
					canDrawTile(buffer2, selectx, selecty);
				}
				if (currentBufferInUse == 3) {
					canDrawTile(buffer3, selectx, selecty);
				}
			}
		}
		if (selectx > 9 || selectx < 0)
		{
			selectx = 0;
		}
		if (selecty > 9 || selecty < 0)
		{
			selecty = 0;
		}
		key = kb_ScanGroup(kb_group_6);
		if (key & kb_Clear) {
			exitSection = true;
		}
		key = kb_ScanGroup(kb_group_1);
		if (key & kb_2nd) {
			if (currentBufferInUse == 1) {
				canDrawTile(buffer1, selectx, selecty);
			}
			if (currentBufferInUse == 2) {
				canDrawTile(buffer2, selectx, selecty);
			}
			if (currentBufferInUse == 3) {
				canDrawTile(buffer3, selectx, selecty);
			}
			if (canDrawTileBool) {
				if (currentBufferInUse == 1) {
					drawTile(buffer1, selectx, selecty);
				}
				if (currentBufferInUse == 2) {
					drawTile(buffer2, selectx, selecty);
				}
				if (currentBufferInUse == 3) {
					drawTile(buffer3, selectx, selecty);
				}

				if (currentBufferInUse == 1) {
					buffer1Active = false;
					clearTile(&buffer1);
				}
				if (currentBufferInUse == 2) {
					buffer2Active = false;
					clearTile(&buffer2);
				}
				if (currentBufferInUse == 3) {
					buffer3Active = false;
					clearTile(&buffer3);
				}
				currentBufferInUse++;
				if (currentBufferInUse == 4) {
					currentBufferInUse = 1;
				}
				checkBuf();
				checkForTileRows();
				if (currentBufferInUse == 1) {
					canDrawTile(buffer1, selectx, selecty);
				}
				if (currentBufferInUse == 2) {
					canDrawTile(buffer2, selectx, selecty);
				}
				if (currentBufferInUse == 3) {
					canDrawTile(buffer3, selectx, selecty);
				}
				anyMovesLeft();
				if (!movesRemaining) {
					exitSection = true;
				}
			}
		}
		if (key & kb_Mode) {
			darkMode = !darkMode;
			while (kb_AnyKey()) {

			}
		}
		key = kb_ScanGroup(kb_group_2);
		if (key & kb_Alpha) {
			currentBufferInUse++;
			if (currentBufferInUse == 4) {
				currentBufferInUse = 1;
			}
			checkBuf();
			while (kb_AnyKey()) {

			}
		}
	}
		saveNewHS(score);
		dead();
}

void dead()
{
	while (kb_AnyKey()) {

	}
	exitSection = false;
	while (exitSection == false) {
		drawBoardRF();
		drawBuffers();
		if (!darkMode) {
            gfx_palette[255] = gfx_RGBTo1555(255, 255, 255);
            
		}
		else {
            gfx_palette[255] = gfx_RGBTo1555(26, 26, 26);
        }

		key = kb_ScanGroup(kb_group_6);
		if (key & kb_Clear) {
			exitSection = true;
		}

		key = kb_ScanGroup(kb_group_1);
		if (!(key & kb_Mode)) {
			gfx_SetColor(0x73);
			gfx_FillRectangle_NoClip(0,40, 320, 40);
            gfx_palette[120] = gfx_RGBTo1555(255, 255, 255);
			gfx_SetTextFGColor(0x7378);
			gfx_SetTextXY(125, 50);
			gfx_PrintString("Game Over");
			gfx_SetTextXY(139, 60);
			gfx_PrintInt(score, 5);
		}
		if (key & kb_2nd) {
			exitSection = true;
			quit = true;
		}
		gfx_SwapDraw();
		gfx_FillScreen(0xFF);
	}
	if (quit) {
		quit = false;
		startGame();
	}
	else {
		main();
	}
}
void checkBuf() {
	if (!buffer1Active && !buffer2Active && !buffer3Active) {
		clearTile(&buffer1);
		clearTile(&buffer2);
		clearTile(&buffer3);
		setRandomTile(&buffer1);
		setRandomTile(&buffer2);
		setRandomTile(&buffer3);
		buffer1Active = true;
		buffer2Active = true;
		buffer3Active = true;
	}
		if (currentBufferInUse == 1 && !buffer1Active) {
			currentBufferInUse++; 
			checkBuf();
		}
		if (currentBufferInUse == 2 && !buffer2Active) {
			currentBufferInUse++;
			checkBuf();
		}
		if (currentBufferInUse == 3 && !buffer3Active) {
			currentBufferInUse=1;
			checkBuf();
		}
		fixBounds();
}
void fixBounds() {
	if (currentBufferInUse == 1) {
		inBounds(buffer1, selectx, selecty);
	}
	if (currentBufferInUse == 2) {
		inBounds(buffer2, selectx, selecty);
	}
	if (currentBufferInUse == 3) {
		inBounds(buffer3, selectx, selecty);
	}
	if (!canDrawTileBool) {
		selectx--;
		selecty--;
		fixBounds();
	}
}
void clearTile(Tile *t) {
	createEmpty(t);
}
void anyMovesLeft() {
	int xx, yy;
	bool movesRemainingSet = false;
	for (xx = 0; xx < 10; xx++)
	{
		for (yy = 0; yy < 10; yy++)
		{
			canDrawTile(buffer1, xx, yy);
			if (canDrawTileBool && buffer1Active) {
				movesRemaining = true;
				movesRemainingSet = true;
			}
			canDrawTile(buffer2, xx, yy);
			if (canDrawTileBool && buffer2Active) {
				movesRemaining = true;
				movesRemainingSet = true;
			}
			canDrawTile(buffer3, xx, yy);
			if (canDrawTileBool && buffer3Active) {
				movesRemaining = true;
				movesRemainingSet = true;
			}
		}
	}
	if (!movesRemainingSet) {
		movesRemaining = false;
	}
}
void setRandomTile(Tile *t) {
	int r = rand() % 13;
	switch (r) {
	default:
		createOne(t);
		break;
	case 0:
		createOne(t);
		break;
	case 1:
		createTwoHorizontal(t);
		break;
	case 2:
		createTwoVertical(t);
		break;
	case 3:
		createThreeHorizontal(t);
		break;
	case 4:
		createThreeVertical(t);
		break;
	case 5:
		createFourHorizontal(t);
		break;
	case 6:
		createFourVertical(t);
		break;
	case 7:
		createFiveHorizontal(t);
		break;
	case 8:
		createFiveVertical(t);
		break;
	case 9:
		create2Sq(t);
		break;
	case 10:
		create3Sq(t);
		break;
	case 11:
	    whichL = rand() % 4;
		if (whichL == 0) {
			create3L1(t);
		}
		if (whichL == 1) {
			create3L2(t);
		}
		if (whichL == 2) {
			create3L3(t);
		}
		if (whichL == 3) {
			create3L4(t);
		}
		break;
	case 12:
		whichL = rand() % 4;
		if (whichL == 0) {
			create5L1(t);
		}
		if (whichL == 1) {
			create5L2(t);
		}
		if (whichL == 2) {
			create5L3(t);
		}
		if (whichL == 3) {
			create5L4(t);
		}
		break;
	}
}

void drawTileHover(Tile t, int tx, int ty) {
	int tn = 0;
	int xn = tx;
	int yn = ty;

	int xx, yy;
	for (xx = 0; xx < 5; xx++)
	{
		for (yy = 0; yy < 5; yy++)
		{
			if (t.shape[xx][yy] == true) { // if the tile is set 
				gfx_SetColor(t.color);
				gfx_FillRectangle_NoClip((xx + xn) * 21 + boardx, (yy + yn) * 21 + boardy, 20, 20);
				fixCorners((xx + xn) * 21 + boardx, (yy + yn) * 21 + boardy);
			}
		}
	}
}
void checkForTileRows() {
	bool columnsClear[10];
	bool rowsClear[10];

	int z;
	for (z = 0; z < 10; z++) {
		checkColumn(z);
		columnsClear[z] = lastClearCheck;
	}

	for (z = 0; z < 10; z++) {
		checkRow(z);
		rowsClear[z] = lastClearCheck;
	}

	for (z = 0; z < 10; z++) {
		if (columnsClear[z]) {
			clearColumn(z);
		}
	}

	for (z = 0; z < 10; z++) {
		if (rowsClear[z]) {
			clearRow(z);
		}
	}
}
bool checkRow(int y) {
	bool yesRow = true;
	int xx;
	for (xx = 0; xx < 10; xx++)
	{
		if (tiles[xx][y] == 0x00) { // if the tile isnt set 
			yesRow = false;
		}
	}
	lastClearCheck = yesRow;
	return yesRow;
}
bool checkColumn(int x) {
	bool yesRow = true;
	int yy;
	for (yy = 0; yy < 10; yy++)
	{
		if (tiles[x][yy] == 0x00) { // if the tile isnt set 
			yesRow = false;
		}

	}
	lastClearCheck = yesRow;
	return yesRow;
}

void clearRow(int y) {
		int xx;
		for (xx = 0; xx < 10; xx++)
		{
			tiles[xx][y] = 0x00;
		}
}
void clearColumn(int x) {
		int yy;
		for (yy = 0; yy < 10; yy++)
		{
			tiles[x][yy] = 0x00;
		}
}
void drawTile(Tile t, int tx, int ty) {
	int tn = 0;
	int xn = tx;
	int yn = ty;

	int xx, yy;
	for (xx = 0; xx < 5; xx++)
	{
		for (yy = 0; yy < 5; yy++)
		{
			if (t.shape[xx][yy] == true) {
				tiles[xx+tx][yy+ty] = t.color;
				score++;
			}
		}
	}
}

bool canDrawTile(Tile t,int tx,int ty) {
	int tn = 0;
	int xn = tx++;
	int yn = ty++;
	bool allowDraw = true;

	int xx, yy;
	for (xx = 0; xx < 5; xx++)
	{
		for (yy = 0; yy < 5; yy++)
		{
			if (t.shape[xx][yy] == true) { // if the tile is set 
				if ((xx + xn) > 9 || (yy + yn) > 9) { //is it out of bounds?
					allowDraw = false;
				}
				if (tiles[xx + xn][yy + yn] != 0x00) { //is there already a tile here?
					allowDraw = false;
				}
			}
		}
	}
	canDrawTileBool = allowDraw;
	return allowDraw;
}
bool inBounds(Tile t, int tx, int ty) {
	int tn = 0;
	int xn = tx++;
	int yn = ty++;
	bool allowDraw = true;

	int xx, yy;
	for (xx = 0; xx < 5; xx++)
	{
		for (yy = 0; yy < 5; yy++)
		{
			if (t.shape[xx][yy] == true) { // if the tile is set 
				if ((xx + xn) > 9 || (yy + yn) > 9) { //is it out of bounds?
					allowDraw = false;
				}
			}
		}
	}
	canDrawTileBool = allowDraw;
	return allowDraw;
}
void drawBoardStart() {
	tilerow = 0;
	tilecolumn = 0;
	tilenumber = 0;
	while (tilenumber < 100) {
		tilenumber++;
        gfx_palette[0] = gfx_RGBTo1555(230, 230, 230);
		gfx_SetColor(0x00);
		gfx_FillRectangle_NoClip(tilecolumn*21+boardx, tilerow*21+boardy,20,20);
		fixCorners(tilecolumn * 21 + boardx, tilerow * 21 + boardy);
		tiles[tilecolumn][tilerow] = 0x00;
		tilecolumn++;
		if (tilecolumn == 10) {
			tilecolumn = 0;
			tilerow++;
		}
	}

}
void drawBoardRF() {
	tilerow = 0;
	tilecolumn = 0;
	tilenumber = 0;
	while (tilenumber < 100) {
		tilenumber++;
		if (!darkMode) {
            gfx_palette[0] = gfx_RGBTo1555(230, 230, 230);
		}
		else {
            gfx_palette[0] = gfx_RGBTo1555(51, 51, 51);
		}
		gfx_SetColor(tiles[tilecolumn][tilerow]);
		gfx_FillRectangle_NoClip(tilecolumn * 21 + boardx, tilerow * 21 + boardy, 20, 20);
		fixCorners(tilecolumn * 21 + boardx, tilerow * 21 + boardy);
		tilecolumn++;
		if (tilecolumn == 10) {
			tilecolumn = 0;
			tilerow++;
		}
	}

}

void fixCorners(int x, int y) {
	gfx_SetColor(0xFF);
	gfx_SetPixel(x, y);
	gfx_SetPixel(x + 1, y);
	gfx_SetPixel(x + 2, y);
	gfx_SetPixel(x + 3, y);
	gfx_SetPixel(x, y + 1);
	gfx_SetPixel(x, y + 2);
	gfx_SetPixel(x, y + 3);
	gfx_SetPixel(x + 1, y + 1);
	gfx_SetPixel(x + 2, y + 1);
	gfx_SetPixel(x + 1, y + 2);

	gfx_SetPixel(x, y+20);
	gfx_SetPixel(x + 1, y+20);
	gfx_SetPixel(x + 2, y + 20);
	gfx_SetPixel(x + 3, y + 20);
	gfx_SetPixel(x, y + 19);
	gfx_SetPixel(x, y + 18);
	gfx_SetPixel(x, y + 17);
	gfx_SetPixel(x + 1, y + 19);
	gfx_SetPixel(x + 2, y + 19);
	gfx_SetPixel(x + 1, y + 18);

	gfx_SetPixel(x + 20, y);
	gfx_SetPixel(x + 20, y + 1);
	gfx_SetPixel(x + 20, y + 2);
	gfx_SetPixel(x + 20, y + 3);
	gfx_SetPixel(x + 19, y);
	gfx_SetPixel(x + 18, y);
	gfx_SetPixel(x + 17, y );
	gfx_SetPixel(x + 19, y + 1);
	gfx_SetPixel(x + 19, y + 2);
	gfx_SetPixel(x + 18, y + 1);

	gfx_SetPixel(x + 20, y + 20);
	gfx_SetPixel(x + 20, y + 19);
	gfx_SetPixel(x + 20, y + 18);
	gfx_SetPixel(x + 20, y + 17);
	gfx_SetPixel(x + 19, y + 20);
	gfx_SetPixel(x + 18, y + 20);
	gfx_SetPixel(x + 17, y + 20);
	gfx_SetPixel(x + 19, y + 19);
	gfx_SetPixel(x + 19, y + 18);
	gfx_SetPixel(x + 18, y + 19);
}

